package com.mingxue.spider.utils;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import com.mingxue.spider.dto.User;

import cn.hutool.core.text.csv.CsvData;
import cn.hutool.core.text.csv.CsvUtil;
import org.springframework.util.CollectionUtils;

public class UserUtil {

    private static List<User> list = new ArrayList<>(12);
    private static User current;
    static {
        initUserInfo();
    }

    private static void initUserInfo(){
        File file = new File("./users.txt");
        if (!file.exists()) {
            file = new File(UserUtil.class.getResource("/users.txt").getFile());
        }
        if (file.exists()) {
            CsvData data = CsvUtil.getReader().read(file);
            data.forEach(row -> {
                list.add(new User().setCode(row.get(0)).setPassword(row.get(1)));
            });
        }
    }

    /**
     * isHn：供湖南使用
     * @return
     */
    public static User next() {
        if(CollectionUtils.isEmpty(list)){
            //如果用户信息被使用完了，重新开始
            initUserInfo();
        }
        User user = list.remove(0);
        user.setIsHn(true);
        current = user;
        list.add(user);
        return user;
    }

    public static User current() {
        return current;
    }
}
