package com.mingxue.spider.utils;

import com.alibaba.fastjson.JSONObject;
import com.mingxue.spider.helper.StringUtils;
import jdk.nashorn.api.scripting.NashornScriptEngine;
import jdk.nashorn.api.scripting.NashornScriptEngineFactory;

import java.io.FileReader;
import java.util.HashMap;
import java.util.Map;

public class UsignUtils {
    public static String getUsign(String jsParam,String jsonParam){
        String[] options = new String[] {"--language=es6"};
        NashornScriptEngineFactory factory = new NashornScriptEngineFactory();

        try {
            NashornScriptEngine engine = getEngine();
            JSONObject jsonObject = JSONObject.parseObject(jsonParam);

            String aaaa= "u_sign('"+jsParam+"',"+jsonObject+")";

            Object o = engine.eval("u_sign('"+jsParam+"',"+jsonParam+")");
//            System.out.println("value : "+o);
            return o.toString();
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public static String getUsign(String jsParam){
        String[] options = new String[] {"--language=es6"};
        NashornScriptEngineFactory factory = new NashornScriptEngineFactory();

        try {
            NashornScriptEngine engine = getEngine();

            Object o = engine.eval("u_sign('"+jsParam+"')");
//            System.out.println("value : "+o);
            return o.toString();
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public static NashornScriptEngine getEngine(){
        /* 1.首先引入js引擎 */
//		ScriptEngineManager manager = new ScriptEngineManager();
        //引擎名称传入JavaScript、js、javascript、nashorn、Nashorn 均可等价
//		ScriptEngine engine = manager.getEngineByName("nashorn");

        String[] options = new String[] {"--language=es6"};
        NashornScriptEngineFactory factory = new NashornScriptEngineFactory();
        NashornScriptEngine engine = (NashornScriptEngine) factory.getScriptEngine(options);

        try {
			/* 2.然后读取js文件 */
            String path = Thread.currentThread().getContextClassLoader().getResource("").getPath(); // 获取targe路径

//            String requestPath = "/youzy.dms.basiclib.api.career.job.hits.inc";
//            String jobCode="02030502";
//            params =requestPath+"?jobCode="+jobCode;

            engine.eval(new FileReader(path + "js/usign.js"));

            return engine;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public static String getRequestPathAndParam(String requestPath,Map<String,Object> paramMap){
        StringBuilder parameter= new StringBuilder();
        int i=0;
        for(Map.Entry<String,Object> entry:paramMap.entrySet()){
            if(i==0){
                parameter.append("?");
            }else {
                parameter.append("&");
            }
            parameter.append(entry.getKey()).append("=").append(entry.getValue());
            i++;
        }
        String jsParam = requestPath+parameter.toString();
        return jsParam;
    }


    public static void main(String[] args) {
        String requestPath = "/youzy.dms.basiclib.api.career.job.hits.inc";
        String jobCode = "02030502";
        Map<String,Object> paramMap =new HashMap<>();
        paramMap.put("jobCode",jobCode);
        System.out.println(getUsign(getRequestPathAndParam(requestPath,paramMap)));

        requestPath = "/youzy.dms.basiclib.api.major.tree.query";
        String eduLevel = "ben";
        paramMap =new HashMap<>();
        paramMap.put("eduLevel",eduLevel);
//        System.out.println(getUsign(getRequestPathAndParam(requestPath,paramMap)));

        requestPath = "/youzy.dms.basiclib.api.major.tree.query";
        String jsonParam="{\"count\":5,\"rankType\":1,\"eduLevel\":\"ben\"}";
        paramMap =new HashMap<>();
        System.out.println(getUsign(getRequestPathAndParam(requestPath,paramMap),jsonParam));
    }
}
